#SingleInstance Off ; allow multiple instances to run concurrently

; get params
Color:=A_Args[1] ; Blue, Green, Red, Master
Debug:=A_Args[2] ; 0 or 1

DetectHiddenWindows,On
CurrentPID:=DllCall("GetCurrentProcessId")
Modifier:="!#"
TrayIconFile:=A_ScriptDir . "\" . Color . ".png" ; for testing, only 3 colors: Blue.png Green.png Red.png - plus Master.png
If (!FileExist(TrayIconFile))
{
  MsgBox,262160,Fatal Error,TrayIconFile does not exist:`n%TrayIconFile%
  ExitApp
}
Menu,Tray,Icon,%TrayIconFile%

If (Color="Master") ; Master assigns the hotkeys
{
  ; for testing, only 3 hotkeys
  HotkeyBlue:=Modifier . "b"
  Hotkey,%HotkeyBlue%,RightClickBlue,On
  HotkeyGreen:=Modifier . "g"
  Hotkey,%HotkeyGreen%,RightClickGreen,On
  HotkeyRed:=Modifier . "r"
  Hotkey,%HotkeyRed%,RightClickRed,On
}

OnMessage(0x404,"AHK_NOTIFYICON")

AHK_NOTIFYICON(wParam,lParam)
{
  global
  DetectHiddenWindows,On
  If ((Debug) and ((lParam=0x202) or (lParam=0x205)))
    MsgBox,,Enter AHK_NOTIFYICON,wParam=%wParam%`nlParam=%lParam%
  If (lParam=0x202) ; WM_LBUTTONUP=0x0202
    Menu,Tray,Show ; show context menu on left click, too
  If (lParam=0x205) ; WM_RBUTTONUP=0x0205
    Menu,Tray,Show ; show context menu on right click - this should actually result in showing menu twice because system should automatically show it
  Return
}

Return ; end auto-execute

RightClickBlue:
PID:=GetColorPID("Blue")
If (PID=-1)
{
  MsgBox Blue not running
  Return
}
If (Debug)
  MsgBox % "right-click Blue currpid=" . CurrentPID . "`nBluePID=" . PID
SendMessage,0x404,,0x205,,ahk_id %PID% ; WM_RBUTTONUP=0x0205
Return

RightClickGreen:
PID:=GetColorPID("Green")
If (PID=-1)
{
  MsgBox Green not running
  Return
}
If (Debug)
  MsgBox % "right-click Green currpid=" . CurrentPID . "`nGreenPID=" . PID
SendMessage,0x404,,0x205,,ahk_id %PID% ; WM_RBUTTONUP=0x0205
Return

RightClickRed:
PID:=GetColorPID("Red")
If (PID=-1)
{
  MsgBox Red not running
  Return
}
If (Debug)
  MsgBox % "right-click Red currpid=" . CurrentPID . "`nRedPID=" . PID
SendMessage,0x404,,0x205,,ahk_id %PID% ; WM_RBUTTONUP=0x0205
Return

GetColorPID(Color)
{
  global
  DetectHiddenWindows,On
  For Process in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process")
  {
    CmdLine:=Process.CommandLine
    CmdPID:=Process.ProcessId
    If (InStr(CmdLine,A_ScriptName) and InStr(CmdLine,Color))
    {
      If (Debug)
        MsgBox,,Color Running Info - %Color%,CmdLine=%CmdLine%`nScriptName=%A_ScriptName%`nCmdPID=%CmdPID%`nCurrentPID=%CurrentPID%
      Return CmdPID ; as soon as it finds process
    }
  }
  Return -1 ; not found after looking through all processes
}
